phiPD <- function(tdist,p){
  D <- tdist^(-p)
  fi_p <- (sum(D))^(1/p)
  return(fi_p)
}

sim.anneal <- function(D_candidates, RestDesign, n, w=NULL, t0=NULL, FAC_t=0.9, Imax = NULL, p=50, range.space=c(-1,1)){
  
  fullDist <- as.matrix(dist(rbind(D_candidates, RestDesign)))
  
  N <- length(D_candidates[,1])
  Dcurrent <- sample(1:N,n,replace=FALSE)

  phiDcurrent <- phiPD(dist(rbind(RestDesign, D_candidates[Dcurrent,])),p)

  Dbest <- Dcurrent
  phiDbest <- phiDcurrent
  t <- t0
  FLAG <- 1

  while(FLAG==1){
    FLAG <- 0
    FLAGd <- 0
    I <- 1
    while(I < Imax){
      Dtry <- Dcurrent
      iold <- sample(1:n,1)
      inew <- sample(c(1:N)[-Dcurrent],1)
      Dtry[iold] <- inew
      phiDtry <- phiPD(dist(rbind(RestDesign, D_candidates[Dtry,])),p)
      if(phiDtry < phiDcurrent){
        Dcurrent <- Dtry
        phiDcurrent <- phiDtry
        FLAG <- 1
        if(FLAGd==0){
          print("Try accepted")
          FLAGd <- 1
        }
      }
      else if((runif(1) < exp(-(phiDtry-phiDcurrent)/t))&(phiDtry!=phiDcurrent)){
        if(FLAGd==0){
          print(paste("Swap forced probability was ", exp(-(phiDtry-phiDcurrent)/t)," phiTry = ", phiDtry, " phiDcurrent = ", phiDcurrent, " t= ", t,sep=""))
          FLAGd <- 1
        }
        Dcurrent <- Dtry
        phiDcurrent <- phiDtry
        FLAG <- 1
      }
      if(phiDtry < phiDbest){
        Dbest <- Dtry
        phiDbest <- phiDtry
        print(paste("New Dbest with phi = ", phiDbest, " found, reset I from I = ", I, sep=""))
        I <- 1
        FLAGd <- 1
      }
      else{
        I <- I + 1
        
      }
    }
    t <- t*FAC_t
    print(t)
    print(paste("Last probability of jump:",exp(-(phiDtry-phiDcurrent)/t), sep=" "))
  }
  return(Dbest)

}